## ros-noetic-tesseract-common 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

# Extract package name and version
find_package(ros_industrial_cmake_boilerplate REQUIRED)
extract_package_metadata(pkg)
project(${pkg_extracted_name} VERSION ${pkg_extracted_version} LANGUAGES CXX)

if(WIN32)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

include(cmake/tesseract_macros.cmake)
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/")

find_package(Boost REQUIRED COMPONENTS system filesystem serialization)
find_package(Eigen3 REQUIRED)
find_package(TinyXML2 REQUIRED)

find_package(console_bridge REQUIRED)
if(NOT TARGET console_bridge::console_bridge)
  add_library(console_bridge::console_bridge INTERFACE IMPORTED)
  set_target_properties(console_bridge::console_bridge PROPERTIES INTERFACE_INCLUDE_DIRECTORIES
                                                                  ${console_bridge_INCLUDE_DIRS})
  set_target_properties(console_bridge::console_bridge PROPERTIES INTERFACE_LINK_LIBRARIES ${console_bridge_LIBRARIES})
else()
  get_target_property(CHECK_INCLUDE_DIRECTORIES console_bridge::console_bridge INTERFACE_INCLUDE_DIRECTORIES)
  if(NOT ${CHECK_INCLUDE_DIRECTORIES})
    set_target_properties(console_bridge::console_bridge PROPERTIES INTERFACE_INCLUDE_DIRECTORIES
                                                                    ${console_bridge_INCLUDE_DIRS})
  endif()
endif()

# Load variable for clang tidy args, compiler options and cxx version
tesseract_variables()

initialize_code_coverage(ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
set(COVERAGE_EXCLUDE
    /usr/*
    /opt/*
    ${CMAKE_CURRENT_LIST_DIR}/test/*
    /*/gtest/*)
add_code_coverage_all_targets(EXCLUDE ${COVERAGE_EXCLUDE} ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})

add_library(
  ${PROJECT_NAME}
  src/joint_state.cpp
  src/manipulator_info.cpp
  src/kinematic_limits.cpp
  src/serialization.cpp
  src/utils.cpp)
target_link_libraries(
  ${PROJECT_NAME}
  PUBLIC Eigen3::Eigen
         ${TinyXML2_LIBRARIES}
         ${CMAKE_DL_LIBS}
         Boost::boost
         Boost::system
         Boost::filesystem
         Boost::serialization
         console_bridge::console_bridge)
target_compile_options(${PROJECT_NAME} PUBLIC ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME} PUBLIC ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME} ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS} ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME} PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
target_include_directories(${PROJECT_NAME} PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                                                  "$<INSTALL_INTERFACE:include>")
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${TinyXML2_INCLUDE_DIRS})

configure_package(NAMESPACE tesseract TARGETS ${PROJECT_NAME})

# Mark cpp header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}
  DESTINATION include
  FILES_MATCHING
  PATTERN "*.h"
  PATTERN "*.hpp"
  PATTERN ".svn" EXCLUDE)

install(FILES "${CMAKE_CURRENT_LIST_DIR}/cmake/tesseract_macros.cmake"
              "${CMAKE_CURRENT_LIST_DIR}/cmake/FindTinyXML2.cmake" "${CMAKE_CURRENT_LIST_DIR}/cmake/Findtcmalloc.cmake"
        DESTINATION lib/cmake/${PROJECT_NAME})

if(TESSERACT_ENABLE_TESTING)
  enable_testing()
  add_run_tests_target(ENABLE ${TESSERACT_ENABLE_RUN_TESTING})
  add_subdirectory(test)
endif()

if(TESSERACT_PACKAGE)
  tesseract_cpack(
    VERSION ${pkg_extracted_version}
    MAINTAINER <https://github.com/ros-industrial-consortium/tesseract>
    DESCRIPTION ${pkg_extracted_description}
    LICENSE_FILE ${CMAKE_CURRENT_LIST_DIR}/../LICENSE
    README_FILE ${CMAKE_CURRENT_LIST_DIR}/../README.md
    LINUX_DEPENDS
      "libboost-system1.71.0"
      "libboost-filesystem1.71.0"
      "libboost-serialization1.71.0"
      "libconsole-bridge-dev"
      "libtinyxml2-dev"
      "libeigen3-dev"
    WINDOWS_DEPENDS
      "boost_system"
      "boost_filesystem;"
      "boost_serialization"
      "tinyxml2"
      "Eigen3")
endif()

=== test/CMakeLists.txt ===
find_package(GTest REQUIRED)

if(NOT TARGET GTest::GTest)
  add_library(GTest::GTest INTERFACE IMPORTED)
  set_target_properties(GTest::GTest PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${GTEST_INCLUDE_DIRS}")
  if(${GTEST_LIBRARIES})
    set_target_properties(GTest::GTest PROPERTIES INTERFACE_LINK_LIBRARIES "${GTEST_LIBRARIES}")
  else()
    if(MSVC)
      set_target_properties(GTest::GTest PROPERTIES INTERFACE_LINK_LIBRARIES "gtest.lib")
    else()
      set_target_properties(GTest::GTest PROPERTIES INTERFACE_LINK_LIBRARIES "libgtest.so")
    endif()
  endif()
endif()

if(NOT TARGET GTest::Main)
  add_library(GTest::Main INTERFACE IMPORTED)
  set_target_properties(GTest::Main PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${GTEST_INCLUDE_DIRS}")
  if(${GTEST_MAIN_LIBRARIES})
    set_target_properties(GTest::Main PROPERTIES INTERFACE_LINK_LIBRARIES "${GTEST_MAIN_LIBRARIES}")
  else()
    if(MSVC)
      set_target_properties(GTest::Main PROPERTIES INTERFACE_LINK_LIBRARIES "gtest_main.lib")
    else()
      set_target_properties(GTest::Main PROPERTIES INTERFACE_LINK_LIBRARIES "libgtest_main.so")
    endif()
  endif()
endif()

include(GoogleTest)

add_executable(${PROJECT_NAME}_unit tesseract_common_unit.cpp)
target_link_libraries(${PROJECT_NAME}_unit PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                    ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_unit ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS} ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_unit
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_unit)
add_dependencies(${PROJECT_NAME}_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_unit)

add_executable(${PROJECT_NAME}_clone_cache_unit clone_cache_unit.cpp)
target_link_libraries(
  ${PROJECT_NAME}_clone_cache_unit
  PRIVATE GTest::GTest
          GTest::Main
          ${PROJECT_NAME}
          console_bridge::console_bridge)
target_compile_options(${PROJECT_NAME}_clone_cache_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_clone_cache_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_clone_cache_unit ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS}
                  ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_clone_cache_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_clone_cache_unit
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_clone_cache_unit)
add_dependencies(${PROJECT_NAME}_clone_cache_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_clone_cache_unit)

add_library(${PROJECT_NAME}_test_plugin_multiply test_plugin_multiply.cpp)
target_link_libraries(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${PROJECT_NAME} Boost::boost)
target_compile_options(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                   ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_test_plugin_multiply ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS}
                  ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_test_plugin_multiply PUBLIC VERSION ${TESSERACT_CXX_VERSION})

add_executable(${PROJECT_NAME}_plugin_loader_unit plugin_loader_unit.cpp)
target_link_libraries(
  ${PROJECT_NAME}_plugin_loader_unit
  PRIVATE GTest::GTest
          GTest::Main
          ${PROJECT_NAME}
          console_bridge::console_bridge)
target_compile_options(${PROJECT_NAME}_plugin_loader_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                  ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_plugin_loader_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_compile_definitions(${PROJECT_NAME}_plugin_loader_unit PRIVATE TEST_PLUGIN_DIR="${CMAKE_CURRENT_BINARY_DIR}")
target_clang_tidy(${PROJECT_NAME}_plugin_loader_unit ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS}
                  ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_plugin_loader_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_plugin_loader_unit
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_plugin_loader_unit)
add_dependencies(${PROJECT_NAME}_plugin_loader_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_plugin_loader_unit)

=== debian/changelog ===
ros-noetic-tesseract-common (0.4.1-1buster) buster; urgency=high

  * Remove windows compiler definition NOMINMAX
  * Do not add compiler option -mno-avx if processor is uknown
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Sat, 24 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-common (0.4.0-1buster) buster; urgency=high

  * Add windows compile definition NOMINMAX
  * Improve tesseract_common unit test coverage
  * Add equal operator support to Any type erasure
  * Fix package build depends
  * Improve tesseract_common unit coverage
  * Disable compile option -mno-avx for arm builds
  * Move printNestedException and leverage forward declarations for tesseract_urdf
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Fri, 23 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-common (0.3.1-1buster) buster; urgency=high

  * Move tesseract_variables() before any use of custom macros
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Wed, 14 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-common (0.3.0-1buster) buster; urgency=high

  * Only enable code coverage if compiler definition is set
  * Move serialize implementation to cpp based on boost documentation for shared libraries
  * Rename Any method cast() and cast_const() to as()
  * Remove NullAny structure
  * Cleanup equal operator
  * Fix satisfiesPositionLimits to use relative equal and calculation of redundant solutions to include all permutations
  * Split loading plugins into two classes ClassLoader and PluginLoader
  * Remove dependency on class_loader and leverage Boost DLL
  * Add PluginLoader class to tesseract_common
  * Fixup enforceJointLimits
    Up to now, it would incorrectly apply the upper limit to any position
    that's outside the range. For example, a position that's slightly under
    the lower limit would get assigned the upper limit. Fix this by using
    Eigen's min and max functions, resulting in a proper clamp.
  * Add satisfy and enforce position limits utility functions (#576 <https://github.com/ros-industrial-consortium/tesseract/issues/576>)
  * Add QueryIntAttributeRequired utility function
  * Add cmake format
  * Add support for defining collision margin data in SRDF (#573 <https://github.com/ros-industrial-consortium/tesseract/issues/573>)
  * Use boost targets, add cpack and license file (#572 <https://github.com/ros-industrial-consortium/tesseract/issues/572>)
  * Fix the way in which Eigen is included (#570 <https://github.com/ros-industrial-consortium/tesseract/issues/570>)
  * Add serializable any type erasure (#555 <https://github.com/ros-industrial-consortium/tesseract/issues/555>)
  * Add ToolCenterPoint unit tests
  * Start to adding boost serialization support
  * Contributors: Hervé Audren, Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Fri, 09 Apr 2021 05:00:00 -0000

ros-noetic-tesseract-common (0.2.0-1buster) buster; urgency=high

  * Improve clone cache unit tests and fix issues with getting clone
  * Allow almostEqualRelativeAndAbs handle empty vectors
  * Refactor tesseract_environment to use applyCommands
  * Add tesseract_common::BytesResource unit test (#545 <https://github.com/ros-industrial-consortium/tesseract/issues/545>)
  * Add simple timer class
  * Add vectorized version of almostEqualRelativeAndAbs to compare if two vectors are equal
  * Update cmake_common_scripts to ros_industrial_cmake_boilerplate
  * Add marker support and remove dependency on command language
  * Update Findtcmalloc.cmake to support windows
  * Add Findtcmalloc.cmake file
  * Move all directories in tesseract directory up one level
  * Contributors: John Wason, Levi Armstrong, Matthew Powelson

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Wed, 17 Feb 2021 06:00:00 -0000

ros-noetic-tesseract-common (0.1.0-1buster) buster; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Thu, 31 Dec 2020 06:00:00 -0000

=== debian/control ===
Source: ros-noetic-tesseract-common
Section: misc
Priority: optional
Maintainer: Levi Armstrong <Levi.Armstrong@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, lcov, libboost-filesystem-dev, libboost-serialization-dev, libboost-system-dev, libclang-dev, libconsole-bridge-dev, libeigen3-dev, libgtest-dev, libtinyxml2-dev, ros-noetic-ros-industrial-cmake-boilerplate
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-tesseract-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-filesystem-dev, libboost-filesystem1.67.0, libboost-serialization-dev, libboost-serialization1.67.0, libboost-system-dev, libboost-system1.67.0, libconsole-bridge-dev, libeigen3-dev, libtinyxml2-dev
Description: Contains common macros, utils and types used throughout

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-tesseract-common//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-tesseract-common//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-tesseract-common 0.18.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 find_package(Boost REQUIRED COMPONENTS system filesystem serialization)
 find_package(Eigen3 REQUIRED)
 find_package(TinyXML2 REQUIRED)
+find_package(yaml-cpp REQUIRED)
 
 find_package(console_bridge REQUIRED)
 if(NOT TARGET console_bridge::console_bridge)
@@ -43,24 +44,30 @@
 
 add_library(
   ${PROJECT_NAME}
+  src/allowed_collision_matrix.cpp
+  src/any_poly.cpp
+  src/collision_margin_data.cpp
   src/joint_state.cpp
   src/manipulator_info.cpp
   src/kinematic_limits.cpp
-  src/serialization.cpp
-  src/utils.cpp)
+  src/eigen_serialization.cpp
+  src/utils.cpp
+  src/resource_locator.cpp
+  src/types.cpp)
 target_link_libraries(
   ${PROJECT_NAME}
   PUBLIC Eigen3::Eigen
-         ${TinyXML2_LIBRARIES}
+         tinyxml2::tinyxml2
          ${CMAKE_DL_LIBS}
          Boost::boost
          Boost::system
          Boost::filesystem
          Boost::serialization
-         console_bridge::console_bridge)
+         console_bridge::console_bridge
+         yaml-cpp)
 target_compile_options(${PROJECT_NAME} PUBLIC ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
 target_compile_definitions(${PROJECT_NAME} PUBLIC ${TESSERACT_COMPILE_DEFINITIONS})
-target_clang_tidy(${PROJECT_NAME} ARGUMENTS ${TESSERACT_CLANG_TIDY_ARGS} ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
+target_clang_tidy(${PROJECT_NAME} ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
 target_cxx_version(${PROJECT_NAME} PUBLIC VERSION ${TESSERACT_CXX_VERSION})
 target_code_coverage(
   ${PROJECT_NAME}
@@ -70,9 +77,11 @@
   ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
 target_include_directories(${PROJECT_NAME} PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
                                                   "$<INSTALL_INTERFACE:include>")
-target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${TinyXML2_INCLUDE_DIRS})
 
 configure_package(NAMESPACE tesseract TARGETS ${PROJECT_NAME})
+if(WIN32)
+  target_link_libraries(${PROJECT_NAME} PUBLIC Bcrypt)
+endif()
 
 # Mark cpp header files for installation
 install(
@@ -83,11 +92,14 @@
   PATTERN "*.hpp"
   PATTERN ".svn" EXCLUDE)
 
-install(FILES "${CMAKE_CURRENT_LIST_DIR}/cmake/tesseract_macros.cmake"
-              "${CMAKE_CURRENT_LIST_DIR}/cmake/FindTinyXML2.cmake" "${CMAKE_CURRENT_LIST_DIR}/cmake/Findtcmalloc.cmake"
-        DESTINATION lib/cmake/${PROJECT_NAME})
+install(
+  FILES "${CMAKE_CURRENT_LIST_DIR}/cmake/tesseract_macros.cmake"
+        "${CMAKE_CURRENT_LIST_DIR}/cmake/FindTinyXML2.cmake"
+        "${CMAKE_CURRENT_LIST_DIR}/cmake/Findtcmalloc.cmake"
+        "${CMAKE_CURRENT_LIST_DIR}/cmake/Findtcmalloc_minimal.cmake"
+  DESTINATION lib/cmake/${PROJECT_NAME})
 
-if(TESSERACT_ENABLE_TESTING)
+if(TESSERACT_ENABLE_TESTING OR TESSERACT_COMMON_ENABLE_TESTING)
   enable_testing()
   add_run_tests_target(ENABLE ${TESSERACT_ENABLE_RUN_TESTING})
   add_subdirectory(test)
@@ -101,16 +113,19 @@
     LICENSE_FILE ${CMAKE_CURRENT_LIST_DIR}/../LICENSE
     README_FILE ${CMAKE_CURRENT_LIST_DIR}/../README.md
     LINUX_DEPENDS
-      "libboost-system1.71.0"
-      "libboost-filesystem1.71.0"
-      "libboost-serialization1.71.0"
+      "libboost-system-dev"
+      "libboost-filesystem-dev"
+      "libboost-serialization-dev"
       "libconsole-bridge-dev"
       "libtinyxml2-dev"
       "libeigen3-dev"
+      "libyaml-cpp-dev"
     WINDOWS_DEPENDS
       "boost_system"
       "boost_filesystem;"
       "boost_serialization"
+      "console-bridge"
       "tinyxml2"
-      "Eigen3")
+      "Eigen3"
+      "yaml-cpp")
 endif()

=== test/CMakeLists.txt ===
find_gtest()

add_executable(${PROJECT_NAME}_serialization_unit tesseract_common_serialization_unit.cpp)
target_link_libraries(${PROJECT_NAME}_serialization_unit PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}_serialization_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                  ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_serialization_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_serialization_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_serialization_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_serialization_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_serialization_unit)
add_dependencies(${PROJECT_NAME}_serialization_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_serialization_unit)

add_executable(${PROJECT_NAME}_unit tesseract_common_unit.cpp)
target_link_libraries(${PROJECT_NAME}_unit PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                    ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_unit)
add_dependencies(${PROJECT_NAME}_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_unit)

add_executable(${PROJECT_NAME}_clone_cache_unit clone_cache_unit.cpp)
target_link_libraries(
  ${PROJECT_NAME}_clone_cache_unit
  PRIVATE GTest::GTest
          GTest::Main
          ${PROJECT_NAME}
          console_bridge::console_bridge)
target_compile_options(${PROJECT_NAME}_clone_cache_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_clone_cache_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_clone_cache_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_clone_cache_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_clone_cache_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_clone_cache_unit)
add_dependencies(${PROJECT_NAME}_clone_cache_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_clone_cache_unit)

add_library(${PROJECT_NAME}_test_plugin_multiply test_plugin_multiply.cpp)
target_link_libraries(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${PROJECT_NAME} Boost::boost)
target_compile_options(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                   ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_test_plugin_multiply PUBLIC ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_test_plugin_multiply ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_test_plugin_multiply PUBLIC VERSION ${TESSERACT_CXX_VERSION})

add_executable(${PROJECT_NAME}_plugin_loader_unit plugin_loader_unit.cpp)
target_link_libraries(
  ${PROJECT_NAME}_plugin_loader_unit
  PRIVATE GTest::GTest
          GTest::Main
          ${PROJECT_NAME}
          console_bridge::console_bridge)
target_compile_options(${PROJECT_NAME}_plugin_loader_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                                  ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_plugin_loader_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_compile_definitions(${PROJECT_NAME}_plugin_loader_unit PRIVATE TEST_PLUGIN_DIR="${CMAKE_CURRENT_BINARY_DIR}")
target_clang_tidy(${PROJECT_NAME}_plugin_loader_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_plugin_loader_unit PUBLIC VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_plugin_loader_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_plugin_loader_unit)
add_dependencies(${PROJECT_NAME}_plugin_loader_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_plugin_loader_unit)

add_executable(${PROJECT_NAME}_resource_unit resource_locator_unit.cpp)
target_link_libraries(${PROJECT_NAME}_resource_unit PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}_resource_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                             ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_compile_definitions(${PROJECT_NAME}_resource_unit PRIVATE ${TESSERACT_COMPILE_DEFINITIONS})
target_clang_tidy(${PROJECT_NAME}_resource_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_resource_unit PRIVATE VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_resource_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_resource_unit)
add_dependencies(${PROJECT_NAME}_resource_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_resource_unit)

add_executable(${PROJECT_NAME}_utils_unit utils_unit.cpp)
target_link_libraries(${PROJECT_NAME}_utils_unit PRIVATE GTest::GTest GTest::Main ${PROJECT_NAME})
target_compile_options(${PROJECT_NAME}_utils_unit PRIVATE ${TESSERACT_COMPILE_OPTIONS_PRIVATE}
                                                          ${TESSERACT_COMPILE_OPTIONS_PUBLIC})
target_clang_tidy(${PROJECT_NAME}_utils_unit ENABLE ${TESSERACT_ENABLE_CLANG_TIDY})
target_cxx_version(${PROJECT_NAME}_utils_unit PRIVATE VERSION ${TESSERACT_CXX_VERSION})
target_code_coverage(
  ${PROJECT_NAME}_utils_unit
  PRIVATE
  ALL
  EXCLUDE ${COVERAGE_EXCLUDE}
  ENABLE ${TESSERACT_ENABLE_CODE_COVERAGE})
add_gtest_discover_tests(${PROJECT_NAME}_utils_unit)
add_dependencies(${PROJECT_NAME}_utils_unit ${PROJECT_NAME})
add_dependencies(run_tests ${PROJECT_NAME}_utils_unit)

=== debian/changelog ===
ros-noetic-tesseract-common (0.18.1-1focal) focal; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Fri, 30 Jun 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.18.0-1focal) focal; urgency=high

  * Add package cmake flags for testing, examples and benchmarks
  * Removed gcc-specific options from clang config
  * Fix JointState equal operator
  * Contributors: Levi Armstrong, Roelof

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Thu, 29 Jun 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.17.0-1focal) focal; urgency=high

  * Windows updates (#893 <https://github.com/tesseract-robotics/tesseract/issues/893>)
  * Update resource_locator.cpp (#889 <https://github.com/tesseract-robotics/tesseract/issues/889>)
  * Contributors: John Wason, Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Tue, 06 Jun 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.16.3-1focal) focal; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Thu, 04 May 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.16.2-1focal) focal; urgency=high

  * Add yaml support for tool path
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Fri, 28 Apr 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.16.1-1focal) focal; urgency=high

  * Improve tesseract_common unit test coverage
  * Improve general resource locator
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Tue, 11 Apr 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.16.0-1focal) focal; urgency=high

  * Add documentation to ContactResultMap
  * Avoid multiple memory allocations in PairHash::operator()
  * Add contact results class
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Sun, 09 Apr 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.15.3-1focal) focal; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Wed, 22 Mar 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.15.2-1focal) focal; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Wed, 15 Mar 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.15.1-1focal) focal; urgency=high



 -- Levi Armstrong <Levi.Armstrong@swri.org>  Tue, 14 Mar 2023 05:00:00 -0000

ros-noetic-tesseract-common (0.15.0-1focal) focal; urgency=high

  * Performance improvements found using callgrind (#852 <https://github.com/tesseract-robotics/tesseract/issues/852>)
  * Update TaskComposerPluginInfo
  * Improve tesseract_state_solver code coverage
  * Fix tesseract_common plugin info implementations equal and insert methods
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Fri, 03 Mar 2023 06:00:00 -0000

ros-noetic-tesseract-common (0.14.0-1focal) focal; urgency=high

  * Add general resource locator
  * Remove deprecated items
  * Add fileToString utility function
  * Rename Any to AnyPoly
  * Remove StatusCode and fix eigen being passed by value in JointState
  * Including <boost/serialization/library_version_type.hpp> for Boost 1.74. Fixes tesseract-robotics/tesseract#764 <https://github.com/tesseract-robotics/tesseract/issues/764>
  * Contributors: Levi Armstrong, Roelof Oomen

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Sun, 23 Oct 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.13.1-1focal) focal; urgency=high

  * Add tesseract extension macro
  * Move most SWIG commands to tesseract_python package (#809 <https://github.com/tesseract-robotics/tesseract/issues/809>)
  * Add isNull method to TypeErasureBase
  * Fix TypeErasure to fully support being null
  * Add find_bullet macro which creates a target to link against (#803 <https://github.com/tesseract-robotics/tesseract/issues/803>)
  * Update almostEqualRelativeAndAbs to support vector of max_diff and max_rel_diff (#802 <https://github.com/tesseract-robotics/tesseract/issues/802>)
  * Contributors: John Wason, Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Thu, 25 Aug 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.13.0-1focal) focal; urgency=high

  * Update code based on clang-tidy-14
  * Make limits utility functions templates
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Mon, 11 Jul 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.10.0-1focal) focal; urgency=high

  * Update ros_industrial_cmake_boilerplate to 0.3.0 (#795 <https://github.com/tesseract-robotics/tesseract/issues/795>)
  * Static plugin loading using symbol module resolution (#782 <https://github.com/tesseract-robotics/tesseract/issues/782>)

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Wed, 06 Jul 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.9.11-1focal) focal; urgency=high

  * Renames in type erasure to avoid WIN32 defines
  * Updated CPack (#786 <https://github.com/tesseract-robotics/tesseract/issues/786>)
  * Update to use find_gtest macro
  * Fix message in type_erasure.h
  * Contributors: John Wason, Levi Armstrong, Michael Ripperger

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Thu, 30 Jun 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.9.10-1focal) focal; urgency=high

  * Add type erasure interface (#776 <https://github.com/tesseract-robotics/tesseract/issues/776>)
    * Add type erasure interface
    * revert change to type erasure constructor
  * Update FindTinyXML2.cmake
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Tue, 14 Jun 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.9.9-1focal) focal; urgency=high

  * Fix find tcmalloc on melodic
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Mon, 30 May 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.9.8-1focal) focal; urgency=high

  * Fix Findtcmalloc_minimal.cmake
  * Contributors: Levi Armstrong

 -- Levi Armstrong <Levi.Armstrong@swri.org>  Mon, 30 May 2022 05:00:00 -0000

ros-noetic-tesseract-common (0.9.7-1focal) focal; urgency=high



=== debian/control ===
Source: ros-noetic-tesseract-common
Section: misc
Priority: optional
Maintainer: Levi Armstrong <Levi.Armstrong@swri.org>
Build-Depends: debhelper (>= 9.0.0), cmake, lcov <!nocheck>, libboost-filesystem-dev, libboost-serialization-dev, libboost-system-dev, libclang-dev <!nocheck>, libconsole-bridge-dev, libeigen3-dev, libgtest-dev <!nocheck>, libtinyxml2-dev, libyaml-cpp-dev, ros-noetic-ros-industrial-cmake-boilerplate
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-tesseract-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-filesystem-dev, libboost-filesystem1.71.0, libboost-serialization-dev, libboost-serialization1.71.0, libboost-system-dev, libboost-system1.71.0, libconsole-bridge-dev, libeigen3-dev, libtinyxml2-dev, libyaml-cpp-dev
Description: Contains common macros, utils and types used throughout

=== debian/rules ===
--- 
+++ 
@@ -17,12 +17,17 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
 
 # Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
 export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
+
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -31,7 +36,8 @@
 	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
